package ClienteServidor;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

/**
* Muestra en dialogo para configurar el puerto del Servidor
* @author 	Alonso Ramrez
* @version 	1.0
* @since       JDK1.0
*/		
public class ConfiguraPuerto extends Dialog implements WindowListener,ActionListener{
	/**
	* En donde se deja el puerto capturado por el usuario
	*/
	public int puerto=ConectorCliente.default_port;
	/**
	* Nos indica si el usuario cancelo o acepto
	*/
	public boolean acepto=false;	
	/**
	* En donde se captura
	*/
	TextField TFPuerto=new TextField();
	
	/**
	* Boton de aceptar
	*/
	Button bAceptar= new Button("Aceptar");
	/**
	* Boton de cancelar
	*/
	Button bCancelar = new Button("Cancelar");
	
	/**
	* @param madre La ventana madre de donde se va a mostrar
	* @param titulo El titulo
	* @param modal si va a ser modal o no
	* @param x coordenada
	* @param y coordenada
	* @param dx ancho
	* @param dy alto
	* @param pPuerto puerto inicial
	*/
	public ConfiguraPuerto(Frame madre,String ttulo,boolean modal,int x,int y,int dx,int dy,int pPuerto) {
		super(madre,ttulo,modal);
		
		setLayout(new GridLayout(4,3));

		TFPuerto.setText(Integer.toString(pPuerto));
		add(new Label(""));
		add(new Label(""));
		add(new Label(""));
		
		add(new Label("Numero de Puerto:"));
		add(TFPuerto);
		add(new Label(""));
		
		add(new Label(""));
		add(new Label(""));
		add(new Label(""));

		add(new Label(""));
		add(bAceptar);
		add(bCancelar);
		
		
		pack();
		setSize(dx,dy);
		setLocation(x,y);
		setModal(modal);
		addWindowListener(this);
		bAceptar.addActionListener(this);
		bCancelar.addActionListener(this);
		
		
		setResizable(false);
		show();
	}
	
		/****************************************************/
    public void windowOpened(WindowEvent e){}
    public void windowActivated(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}
    public void windowClosed(WindowEvent e){}
	public void windowClosing(WindowEvent e){
		hide();
		setVisible(false);
	}
	
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==bAceptar){
			if(TFPuerto.getText().equals(""))
				return;
			try{
				puerto=Integer.parseInt(TFPuerto.getText());					
			}
			catch(NumberFormatException ne){
				return;
			}
			//indicar que acepto
			acepto=true;
		}
		windowClosing(new WindowEvent(this,WindowEvent.WINDOW_CLOSING));
	}


}
