package ClienteServidor;

import java.applet.*;
import java.awt.*;
import java.awt.event.*;

/**
* Muestra en dialogo para configurar los datos del cliente
* Host, login , password y puerto
* @author 	Alonso Ramrez
* @version 	1.0
* @since       JDK1.0
*/		
public class ConfiguradorCuenta extends Dialog implements WindowListener,ActionListener{
	/**
	* en donde se deja login capturado
	*/
	public String login="";
	/**
	* en donde se deja password capturado
	*/
	public String password="";
	/**
	* en donde se deja servidor capturado
	*/
	public String servidor="";
	/**
	* en donde se deja puerto capturado
	*/
	public String puerto="";
	
	/**
	* De Captura
	*/
	TextField TFLogin=new TextField();
	/**
	* De Captura
	*/
	TextField TFPassword=new TextField();
	/**
	* De Captura
	*/
	TextField TFServidor=new TextField();
	/**
	* De Captura
	*/
	TextField TFPuerto=new TextField();
	
	Button bAceptar,bCancelar;
	Label lbP;
	
	/**
	* @param madre La ventana madre de donde se va a mostrar
	* @param titulo El titulo
	* @param modal si va a ser modal o no
	* @param x coordenada
	* @param y coordenada
	* @param dx ancho
	* @param dy alto
	* @param plogin login inicial
	* @param pPassword inicial
	* @param pservidor puerto inicial
	* @param pPuerto puerto inicial
	*/
	public ConfiguradorCuenta(Frame madre,String ttulo,boolean modal,int x,int y,int dx,int dy,String pLogin,String pPassword,String pServidor, String pPuerto) {
		super(madre,ttulo,modal);
		setLayout(new BorderLayout());
		Panel pC= new Panel(new GridLayout(7,2));
		
		pC.add(new Label("Servidor: "));pC.add(TFServidor);

		pC.add(new Label());pC.add(new Label());// separador
		
		pC.add(new Label("Login: ")); pC.add(TFLogin);
		
		pC.add(new Label("Password :")); pC.add(TFPassword);

		pC.add(new Label());pC.add(new Label());// separador
		
		pC.add(lbP= new Label("Puerto :")); pC.add(TFPuerto);

		pC.add(new Label());pC.add(new Label());// separador
		
		
		
		add("Center",pC);
		add("East",new Label());
		add("West",new Label());
		Panel pS= new Panel(new GridLayout(1,2));
		
		pS.add(bAceptar=new Button("Aceptar"));
		pS.add(bCancelar=new Button("Cancelar"));
		add("South",pS);
		
		pack();
		setSize(dx,dy);
		setLocation(x,y);
		setModal(modal);
		addWindowListener(this);
		bAceptar.addActionListener(this);
		bCancelar.addActionListener(this);
		
		TFLogin.setText(pLogin);
		TFPassword.setText(pPassword);
		TFServidor.setText(pServidor);
		TFPuerto.setText(pPuerto);
		
		login=pLogin;
		password=pPassword;
		servidor=pServidor;
		puerto=pPuerto;
		
		setResizable(false);
		show();
	}
	
		/****************************************************/
    public void windowOpened(WindowEvent e){}
    public void windowActivated(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}
    public void windowClosed(WindowEvent e){}
	public void windowClosing(WindowEvent e){
		hide();
		setVisible(false);
	}
	/**
	* respuesta de usuario
	*/
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==bAceptar){
			//checar que el puerto es numerico
			try{
				Integer.parseInt(TFPuerto.getText());
			}
			catch(NumberFormatException nfe){
				// no dejar pasar
				System.err.println("EL puerto no es un numero Valido");
				lbP.setText("Puerto :    ** No valido **");
				return;
			}
			// guardar valores
			login=TFLogin.getText();
			password=TFPassword.getText();
			servidor=TFServidor.getText();
			puerto=TFPuerto.getText();
			
		}
		else if(e.getSource()==bCancelar){
			
		}
		windowClosing(new WindowEvent(this,WindowEvent.WINDOW_CLOSING));
	}


}

