package ClienteServidor;

import java.awt.*;
import java.awt.event.*;
import java.io.*;

/**
* Interfas Grafica que es capaz de mandar y recibir mensajes con un Conector de
* cliente. Permite que el usuario interactue y configure.
* @author 	Alonso Ramrez
* @version 	1.0
* @since       JDK1.0
*/		
class InterfasGraficaCliente extends Frame implements RecibidorMensajesCliente,WindowListener,ActionListener,FilenameFilter{
	/**
	* Menu de interfas
	*/
	MenuBar mB=new MenuBar();
	/**
	* Menu de interfas
	*/
	Menu mPrincipal=new Menu("Principal");
	/**
	* Menu de interfas
	*/
	Menu mConfiguracion=new Menu("Configuracion");
	/**
	* Menu de interfas
	*/
	MenuItem mIConectar=new MenuItem("Conectar");
	/**
	* Menu de interfas
	*/
	MenuItem mIDesconectar=new MenuItem("Desconectar");
	
	/**
	* Menu de interfas
	*/
	MenuItem mICliente = new MenuItem("Datos de Cliente");
	
	/**
	* Para mensajes al usuario
	*/
	Label lbMensajes = new Label("Desconectado.");
	/**
	* informacion
	*/
	Label lbOpciones = new Label("Tipos de informacion:");
	
	/**
	* Selector de informacion
	*/
	Choice chTipoInformacion = new Choice();
	
	/**
	* obtener informacion
	*/
	Button bGetInfo = new Button("Obtener Informacion");	

	/**
	* muestra informacion
	*/
	TextField TFInformacion = new TextField("No ha llegado informacion...");

	/**
	* Para recibir un archivo
	*/
	Button bRecibeArch = new Button("Recibir Archivo");

	/**
	* para mostra informacion de Archivos
	*/
	TextArea TAInfoArch= new TextArea("No hay Informacion de Archivo");	
	
	/**
	* El login
	*/
	String login="" ;//= "Alonso";
	/**
	* El password
	*/
	String passw="" ;//= "1234";
	/**
	* El servidor
	*/
	String host = "";//= "Power450Lab";
	/**
	* El puerto
	*/
	int port = ConectorCliente.default_port;
	/**
	* El Conector de Sockets con el cliente
	*/
	ConectorCliente conecCli;
	
	/**
	* Acomoda la interfas grafica
	*/
	InterfasGraficaCliente(){
		

		setMenuBar(mB);
		
		mB.add(mPrincipal);
		mB.add(mConfiguracion);
		
		
		mPrincipal.add(mIConectar);
		mPrincipal.add(mIDesconectar);

		mConfiguracion.add(mICliente);
		
		setLayout(new BorderLayout());
		Panel pN  = new Panel();
		Panel pC  = new Panel();
		Panel pNC = new Panel();
		Panel pCS = new Panel();
		Panel pS = new Panel();
		Panel pSW = new Panel();
		
		pS.setLayout(new BorderLayout());
		
		pS.add("West",pSW);
		pS.add("Center",lbMensajes);
		pSW.setSize(new Dimension(400,400));

		
		pN.setLayout(new GridLayout(1,3));
		pC.setLayout(new BorderLayout());
		pNC.setLayout(new BorderLayout());
		
		pCS.setLayout(new GridLayout(1,3));
		pCS.add(bRecibeArch);
		pCS.add(new Label());
		pCS.add(new Label());
		

		pC.add("North",pNC);
		pC.add("Center",TAInfoArch);
		pC.add("South",pCS);

		pNC.add("North",TFInformacion);
		pNC.add("South",new Label());
		pNC.add("Center",new Label());
		

		pN.add(lbOpciones);
		pN.add(chTipoInformacion);
		pN.add(bGetInfo);
		
		add("North",pN);
		add("Center",pC);
		add("South",pS);
		
		lbMensajes.setBackground(Color.blue);
		lbMensajes.setForeground(Color.white);
		lbMensajes.setFont(new Font("",Font.BOLD,13));

		lbOpciones.setBackground(Color.blue);
		lbOpciones.setForeground(Color.white);
		lbOpciones.setFont(new Font("",Font.BOLD,13));
		
		chTipoInformacion.add("La Hora");
		chTipoInformacion.add("El Clima");
		chTipoInformacion.add("Lista de Clientes");
		chTipoInformacion.add("Lista Archivos Disponibles");

		addWindowListener(this);
		
		mIConectar.addActionListener(this);
		mIDesconectar.addActionListener(this);
		
		mICliente.addActionListener(this);
	
		bRecibeArch.addActionListener(this);
		bGetInfo.addActionListener(this);
		
		// inicializar a deconectado
		estadoDesconectado();
		
		/**
		* Permitir que el usuario capture los datos
		*/
		ConfiguradorCuenta cC = new ConfiguradorCuenta(this,"Configura Conexion :-) ",true,10,10,350,210,login,passw,host, Integer.toString(port) );
		login = new String(cC.login);
		passw = new String(cC.password);
		host = new String(cC.servidor);
		port = Integer.parseInt(cC.puerto);
		cC.dispose();


	}
	
	/**
	* Ejecuta la creacion de la interfas
	*/
	public static void main(String args[]){
		InterfasGraficaCliente mainFrame = new InterfasGraficaCliente();
		
		mainFrame.setSize(500, 400);
		mainFrame.setTitle("El Cliente:");
		mainFrame.setVisible(true);
		
	}
	
	/*Funciones de Recibidor de Mensajes**********************/
	
	/**
	* @see RecibidorMensajesCliente
	*/
	public void conectado(String informacion){
		lbMensajes.setText(informacion);
		mIDesconectar.setEnabled(true);
		bGetInfo.setEnabled(true);
		bRecibeArch.setEnabled(true);

	}
	/**
	* @see RecibidorMensajesCliente
	*/
	public void noPudeConectar(String informacion){
		lbMensajes.setText(informacion);	
	}
	/**
	* @see RecibidorMensajesCliente
	*/
	public void desconectado(String informacion){
	}
	
	/**
	* @see RecibidorMensajesCliente
	*/
	public void llegoInformacion(String Informacion){
		TFInformacion.setText(Informacion);
	}
	/**
	* @see RecibidorMensajesCliente
	*/
	public void llegoListaClientes(String lista){
		String cliente;
		TAInfoArch.setText("La Lista de Clientes en el Servidor es:\n");
		int i = 0;	
		
		//separar la lista
		do{
			i=lista.indexOf(",");
			if(i>0){
				cliente = lista.substring(0,i);
				TAInfoArch.append(cliente+"\n");
				lista=lista.substring(i+1);
			}
		}while(i>0);
		
	}
	
	/**
	* @see RecibidorMensajesCliente
	*/
	public void llegoListaArchivos(String lista){
		String cliente;
		//System.out.println("lista>"+lista+"<"+lista.length());
		if(lista.length() <1){
			TAInfoArch.setText("No hay Archivos en el servidor\n");
			return;
		}
		
		TAInfoArch.setText("La Lista de Archivos en el Servidor es:\n");
		int i = 0;	
		// separar la lista
		do{
			i=lista.indexOf(",");
			if(i>0){
				cliente = lista.substring(0,i);
				TAInfoArch.append(cliente+"\n");
				lista=lista.substring(i+1);
			}
		}while(i>0);
		
	}
	
	/**
	* @see RecibidorMensajesCliente
	*/
	public void llegoArchivo(String contenido){

		if(contenido.length() <1){
			TAInfoArch.setText("El archivo no existe en el servidor o esta vacio\n");
			return;
		}

		TAInfoArch.setText("El contenido del archivo solicitado es:\n");
		
		byte arch[] = contenido.getBytes();
		
		// regresar los retorno de carro y los avance de linea
		for(int i=0;i<arch.length;i++){
			if((int)arch[i] == (byte)'~')
				arch[i]=(byte)13;
			else if((int)arch[i] == (byte)'$')
				arch[i]=(byte)10;
		}
		
		// mostrar el archivo en pantalla
		TAInfoArch.append(new String(arch));
		TAInfoArch.setCaretPosition(0);
		TAInfoArch.setSelectionStart(0);


	}
	/**
	* @see RecibidorMensajesCliente
	*/
	public void mensajeATodos(String mensaje){
		TFInformacion.setText("Informacion de Servidor: "+mensaje);
	}


	/*Funciones de Window ****************************************/
	/**
	*
	*/
    public void windowOpened(WindowEvent e){}
	/**
	*
	*/
    public void windowActivated(WindowEvent e){}
	/**
	*
	*/
    public void windowDeactivated(WindowEvent e){}
	/**
	*
	*/
    public void windowIconified(WindowEvent e){}
	/**
	*
	*/
    public void windowDeiconified(WindowEvent e){}
	/**
	*
	*/
    public void windowClosed(WindowEvent e){}
    /**
    * Hace logout al servidor , libera recursos y termina
    */
	public void windowClosing(WindowEvent e){
		if(conecCli != null && conecCli.conectado == true){
			System.out.println("Si estaba conectado");
			conecCli.hacerLogOut();
			estadoDesconectado();
		}
		setVisible(false);
		dispose();
		System.exit(0);
	}
	
	/*Funciones de Action Event*******************************************************/
	/**
	* Da mantenimiento a los botones y a los menus
	*/
	public void actionPerformed(ActionEvent e){
		if(e.getSource() == mIConectar){
			// crear un nuevo conector
			conecCli = new ConectorCliente(login,passw,host,port,this);
		}
		else if(e.getSource() == mIDesconectar){
			// deconectar, hacer logout y cerrar el conector
			conecCli.hacerLogOut();
			estadoDesconectado();
		}
		else if(e.getSource() == bRecibeArch){
			// escojer un archivo para pedirlo
			EscojeArchivo eA = new EscojeArchivo(this,"Escoje el Archivo a Recibir :-) ",true,10,10,350,150 );
			if(eA.acepto==false){
				return;
			}
			//pedirlo
			conecCli.pideArchivo(eA.archivo);
			// liberar los recursos del dialogo
			eA.dispose();
			
		}
		else if(e.getSource() == mICliente){
			// configurar el cliente
			ConfiguradorCuenta cC = new ConfiguradorCuenta(this,"Configura Conexion :-) ",true,10,10,350,210,login,passw,host, Integer.toString(port) );
			login = new String(cC.login);
			passw = new String(cC.password);
			host = new String(cC.servidor);
			port = Integer.parseInt(cC.puerto);
			
			cC.dispose();
		}
		else if(e.getSource()==bGetInfo){
			//pedir la informacion al conector de cliente
			if(chTipoInformacion.getSelectedIndex()==0){
				conecCli.pideHora();
			}
			else if(chTipoInformacion.getSelectedIndex()==1){
				conecCli.pideClima();
			}
			else if(chTipoInformacion.getSelectedIndex()==2){
				conecCli.pideListaClientes();
			}
			else if(chTipoInformacion.getSelectedIndex()==3){
				conecCli.pideListaArchivos();
			}
		}

	}

	/**
	* Poner la interfas en estado de desconectado
	*/
	private void estadoDesconectado(){
		lbMensajes.setText("Desconectado");
		conecCli=null;
		// apagar los controles
		mIDesconectar.setEnabled(false);
		bGetInfo.setEnabled(false);
		bRecibeArch.setEnabled(false);
	}
	
	public void servidorAbajo(){
		lbMensajes.setText("El Servidor esta Abajo...");
		conecCli.desconectar();
		conecCli=null;
		// apagar los controles
		mIDesconectar.setEnabled(false);
		bGetInfo.setEnabled(false);
		bRecibeArch.setEnabled(false);		
	}

	/**
	* El filtro de la interfas FileNameFilter
    * @see  FilenameFilter
	*/
	public boolean accept(File dir, String file) {
		if(!file.endsWith(".txt"))
			return false;
		return true;
	}

}

