package ClienteServidor;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Date;

/**
* Interfas Grafica que es capaz de mandar y recibir mensajes con un Conector de
* servidor. Permite que el usuario interactue y configure.
* @author 	Alonso Ramrez
* @version 	1.0
* @since       JDK1.0
*/		
class InterfasGraficaServidor extends Frame implements RecibidorMensajesServidor,WindowListener,ActionListener{
	/**
	* menu de interfas
	*/
	MenuBar mB=new MenuBar();
	/**
	* menu de interfas
	*/
	Menu mConfiguracion=new Menu("Configuracion");
	/**
	* menu de interfas
	*/
	MenuItem mIServidor = new MenuItem("Datos de Servidor");
	
	/**
	* De interfas
	*/
	Label lbMensajes = new Label("Desconectado.");

	/**
	* De interfas
	*/
	TextField TFMensajeATodos = new TextField();
	/**
	* De interfas
	*/
	Button bMandaATodos = new Button("Manda un Mensaje a Todos");	

	/**
	* De interfas
	*/
	TextField TFInformacion = new TextField("No ha llegado informacion...");


	/**
	* De interfas
	*/
	TextArea TABitacora = new TextArea("");	
	
	/**
	* De interfas
	*/
	Choice chClientes = new Choice();
	
	/**
	* el puerto donde se conecta ConectorServidor
	*/
	int port = ConectorCliente.default_port;
	
	/**
	* El Conector de Servidor
	*/
	ConectorServidor conecServer;
	
	/**
	* Prepara la interfas grafica con todos sus componentes, inicializa el conector
	* de servidor y dispara el configurador inicial.
	*/
	InterfasGraficaServidor(){
		
		// Preparar interfas
		Label lbTitulo = new Label("Bitacora de servidor");
		Label lbClientes = new Label("Clientes:");
		lbClientes.setAlignment(Label.CENTER); 
		lbClientes.setBackground(Color.red);
		lbClientes.setForeground(Color.white);
		lbClientes.setFont(new Font("",Font.BOLD,13));

		lbTitulo.setForeground(Color.red);
		lbTitulo.setFont(new Font("",Font.BOLD,13));

		setMenuBar(mB);
		
		mB.add(mConfiguracion);
		
		mConfiguracion.add(mIServidor);


		setLayout(new BorderLayout());
		Panel pN  = new Panel();
		Panel pS = new Panel();
		Panel pSW = new Panel();
		Panel pNS  = new Panel();
		pNS.setLayout(new GridLayout(1,3));
		
		pNS.add(lbTitulo);
		pNS.add(lbClientes);
		pNS.add(chClientes);
		
		pN.setLayout(new BorderLayout());
		
		pN.add("Center",TFMensajeATodos);
		pN.add("East",bMandaATodos);
		pN.add("South",pNS);
		
		add("Center",TABitacora);
		
		pS.setLayout(new BorderLayout());
		
		pS.add("West",pSW);
		pS.add("Center",lbMensajes);
		
		pSW.setSize(new Dimension(400,400));

		
		add("North",pN);
		add("South",pS);
		
		lbMensajes.setBackground(Color.red);
		lbMensajes.setForeground(Color.white);
		lbMensajes.setFont(new Font("",Font.BOLD,13));

		
		addWindowListener(this);
		
	
		bMandaATodos.addActionListener(this);
		mIServidor.addActionListener(this);
		
		// Dispara el Configurador
		ConfiguraPuerto cP = new ConfiguraPuerto(this,"Configura el puerto del socket servidor :-) ",true,10,10,350,150,port );
		port = cP.puerto;
		cP.dispose();
		
		// Conecta como servidor
		conecServer = new ConectorServidor(port,this);
	}
	
	/**
	* Crea  la aplicacion
	*/
	public static void main(String args[]){
		InterfasGraficaServidor mainFrame = new InterfasGraficaServidor();
		
		mainFrame.setSize(500, 400);
		mainFrame.setTitle("EL Servidor:");
		mainFrame.setVisible(true);
	}
	
	/**
	* Devuelve como cadena la hora actual
	*/
	public String hora(){
		Date d = new Date();
		return "\n"+d.getHours()+":"+d.getMinutes()+":"+d.getSeconds()+": ";
	}
	
	/*Funciones de Recibidor de Mensajes**********************/
	/**
	* @see RecibidorMensajesServidor
	*/
	public void conectado(String informacion){
		lbMensajes.setText(informacion);
		TABitacora.append(hora()+"En linea...");
	}
	/**
	* @see RecibidorMensajesServidor
	*/
	public void noPudeConectar(String informacion){
		lbMensajes.setText(informacion);
	}

	/**
	* @see RecibidorMensajesServidor
	*/
	public void llegoClienteNuevo(String idCliente){
		TABitacora.append(hora()+idCliente);
	}

	/**
	* @see RecibidorMensajesServidor
	*/
	public void seDioDeBajaCliente(String idCliente){
		TABitacora.append(hora()+"Se dio de Baja :"+idCliente);
		chClientes.remove(idCliente);
	}
	
	/**
	* @see RecibidorMensajesServidor
	*/
	public void accionCliente(String idCliente,String accion){
		TABitacora.append(hora()+"El cliente "+idCliente+" "+accion);

	}

	/**
	* @see RecibidorMensajesServidor
	*/
	public void seDioDeAltaunClienteNuevo(String idCliente){
		TABitacora.append(hora()+"Se ha dado de alta: "+idCliente);
		chClientes.add(idCliente);
	}

	/**
	* @see RecibidorMensajesServidor
	*/
	public void noSeIdentificoClienteNuevo(String idCliente){
		TABitacora.append(hora()+"Fracaso el dado de alta de: "+idCliente);
	}


	/*Funciones de Window ****************************************/
    public void windowOpened(WindowEvent e){}
    public void windowActivated(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}
    public void windowClosed(WindowEvent e){}
    /**
    * Desconecta , avisa a los clientes y libera recursos
    */
	public void windowClosing(WindowEvent e){
		
		System.out.println("aqui");
		if(conecServer != null && conecServer.conectado == true){
			conecServer.desconectar();
		}
		setVisible(false);
		dispose();
		System.exit(0);
	}
	
	/*Funciones de Action Event*******************************************************/
	/**
	* Da mantenimiento a todos los eventos de botones y menus de la interfas
	*/
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==bMandaATodos){
			// manda un mensaje a todos
			conecServer.mandaMensajeATodos(TFMensajeATodos.getText());
			TABitacora.append(hora()+"El servidor mando a todos '"+TFMensajeATodos.getText()+"'");

		}
		else if(e.getSource() == mIServidor){

			// Configurar
			ConfiguraPuerto cP = new ConfiguraPuerto(this,"Configura el puerto del socket servidor :-) ",true,10,10,350,150,port );
			if(cP.acepto){
				if(port != cP.puerto){
					conecServer.desconectar();
					conecServer=null;
					chClientes.removeAll(); //limpiar la lista de clientes
					TABitacora.append(hora()+"El servidor ha dejado de dar servicio");

					System.gc();
					conecServer = new ConectorServidor(cP.puerto,this);		
				}
				port = cP.puerto;
			}
			cP.dispose();
			
			
		}


	}


}

