package ClienteServidor;

import java.io.*;

/**
* Implementando la interfas FilenameFilter regresa una lista
* de los archivos con la estension ext
*/
public class ListaDeArchivos implements FilenameFilter {
	/**
	* La extension de los archivos
	*/
	public  String ext=".tf";
	/**
	* el directorio donde se va a buscar
	*/
	private String directorio="."+File.separator;
	
	/**
	* El vector de Archivos
	*/
	public  String[] files;
	

	/**
	* con este metodo se obtiene la lista de archivos en el miembro
	* files
	*/
	public void obtiene() {
		if (!ext.startsWith(".")) { 
			ext="."+ext; 
		}
		File d=new File(directorio);
		if (d.exists()) { 
			files=d.list(this);
		}
		else
			files = null;
	}

	/**
	* La funcio de Aceptacion de si un archivo se incluye o no en la lista
	*/
	public boolean accept(File d,String name) {
		if (ext.equals(".*")) { 
			return true; 
		}
		
		File test=new File(d,name);
		if (test.isFile()) { 
			return (name.lastIndexOf(ext)==(name.length()-ext.length())); 
		} else { 
			return false; 
		}
	}

}

