package ClienteServidor;

/**
* Interfas que establece el compromiso entre un conector Cliente
* de sockets y una interfas grafica de usuario de Cliente
* @author 	Alonso Ramrez
* @version 	1.0
* @since       JDK1.0
*/		

public interface RecibidorMensajesCliente{
	
	/**
	* Hay conexion, el cliente de sockets se ha conectado con el servidor
	* @param informacion Informacion de la conexion
	*/
	public void conectado(String informacion);
	/**
	* No se pudo conectar con un servidor de sockets
	* @param Informacion Indica porque no pudo
	*/
	public void noPudeConectar(String Informacion);
	/**
	* El cliente de Sockets se ha desconectado
	* @param informacion de porque
	*/
	public void desconectado(String informacion);
	
	/**
	* Llego informacion generica del servidor
	* @param Informacion la informacion llegada
	*/
	public void llegoInformacion(String Informacion);

	/**
	* Llego la lista de clientes del servidor
	* @param lista La lista de clientes separada por comas
	*/
	public void llegoListaClientes(String lista);
	
	/**
	* Llego la lista de archivos del servidor
	* @param lista La lista de archivos separada por comas
	*/
	public void llegoListaArchivos(String lista);

	/**
	* Llego un archivo del servidor
	* @param contenido El contenido del archivo
	*/
	public void llegoArchivo(String contenido);

	/**
	* El servidor dejo de dar servicio
	*/
	public void servidorAbajo();

	/**
	* El servidor mando un mensaje a todos sus clientes
	* @param mensaje El mensaje que mando el servidor
	*/
	public void mensajeATodos(String mensaje);
}