package ClienteServidor;

/**
* Interfas que establece el compromiso y da la funcionalidad entre
* un servidor de sockets y una Interfas grafica de Usuario de Servidor
* @author 	Alonso Ramrez
* @version 	1.0
* @since       JDK1.0
*/		
public interface RecibidorMensajesServidor{
	
	/**
	* El servidor esta conectado y escuchando correctamente
	* @param informacion    La informacion de la conexion
	*/
	public void conectado(String informacion);
	
	/**
	* El servidor no pudo abrir un socket para ponerse a escuchar
	* @param informacion    La informacion de la falla en la conexion
	*/
	public void noPudeConectar(String Informacion);
	
	/**
	* Ha llegado un posible cliente nuevo (todavia no se autentifica)
	* @param idCliente    La informacion del nuevo cliente que llega
	*/
	public void llegoClienteNuevo(String idCliente);

	/**
	* Se ha autentificado un cliente nuevo
	* @param idCliente    El id del nuevo cliente que llega
	*/
	public void seDioDeAltaunClienteNuevo(String idCliente);

	/**
	* Fracaso la autentificacion de un cliente nuevo,
	* @param idCliente    El id y el password del nuevo cliente que llega
	*/
	public void noSeIdentificoClienteNuevo(String idCliente);

	/**
	* Se ha dado de baja un cliente
	* @param idCliente    El id del cliente que se da de baja
	*/
	public void seDioDeBajaCliente(String idCliente);
	
	/**
	* El cliente ha solicitado una peticion
	* @param idCliente    El id del cliente que ha hecho la peticion
	*/
	public void accionCliente(String idCliente,String Accion);
	
}