package ClienteServidor;

import java.net.*;
import java.io.*;
import java.applet.*;
import java.awt.*;
import java.awt.event.*;
		
public class ConectorCliente implements Runnable { 

	public static final int default_port=6789;
	private Socket s;
	private BufferedReader sin;
	private PrintStream sout;
	private String login;
	public boolean pleaseStop=false;
	boolean solo;
	RecibidorMensajesCliente interfasGrafica;
	public boolean conectado = false;
	Thread th;
		
	
	public void pideHora(){
		send(Protocolo.TK_MANDA_HORA + Protocolo.chk("") + ":");
	}	
	public void pideClima(){
		send(Protocolo.TK_MANDA_CLIMA + Protocolo.chk("") + ":");
	}	
	public void pideListaClientes(){
		send(Protocolo.TK_MANDA_CLIENTES + Protocolo.chk("") + ":");
	}	
	public void pideListaArchivos(){
		send(Protocolo.TK_MANDA_LISTA_ARCH + Protocolo.chk("") + ":");
	}	
	public void pideArchivo(String nombre){
		send(Protocolo.TK_RECIBE_ARCH + Protocolo.chk("") + ":"+nombre);
	}	
	
	public ConectorCliente(String login,String password,String host,int port, RecibidorMensajesCliente interfasG) {
		interfasGrafica  = interfasG;
		solo=true;
		if(port==0)
			construct(login,password,host,default_port);
		else
			construct(login,password,host,port);
	}
	
	public void hacerLogOut(){
		send(Protocolo.TK_LOGOUT + Protocolo.chk("") + ":");
		pleaseStop = true;
		th.stop();
	}

	public void desconectar(){
		pleaseStop = true;
		th.stop();
	}
	
	

	
	void construct(String login,String password,String host,int port) {
		this.login=login;
		try {
			
			s=new Socket(host,port);
			sin = new BufferedReader(new InputStreamReader(s.getInputStream()));
			sout= new PrintStream(s.getOutputStream());
			
			
			/*mandar Log In y password*/
			
			sout.println(Protocolo.TK_LOGIN+Protocolo.chk("")+":"+login+","+password);

			//y esperar a que conteste el servidor
			th=new Thread(this); 
			th.start();
			
			
		} catch (IOException e) {
			interfasGrafica.noPudeConectar("No pude conectar: "+ e.toString());
			System.err.println(e);
		}
	}
	
	void send(String msg) {
		if (msg==null||msg.length()==0) {
		} else {
			sout.println(msg);
		}
	}
	
	void println(String msg) {
		System.out.println(msg);
	}

	public void run() {
		while (!pleaseStop) {
			try {
				String line=sin.readLine();
				if (line==null) { 
					System.out.println("Connection closed by server.");
					break;
				}
				if(conectado==false){

					if(line.startsWith(Protocolo.TK_LOGIN_OK)){
						conectado=true;
						interfasGrafica.conectado(login+" conectado a: "+s.getInetAddress().getHostName()+" : " + s.getPort());
					}
					else if(line.startsWith(Protocolo.TK_LOGIN_MAL)){
						interfasGrafica.noPudeConectar("Desconectado: Login incorrecto");
						break;
					}
					else if(line.startsWith(Protocolo.TK_PASSWORD_MAL)){
						interfasGrafica.noPudeConectar("Desconectado: Password incorrecto");
						break;
					}
				}
				else{ // ya hay conexion con servidor, esta es informacion
					if(line.startsWith(Protocolo.TK_MANDA_HORA)){
						interfasGrafica.llegoInformacion(line.substring(5));
					}
					else if(line.startsWith(Protocolo.TK_MANDA_CLIMA)){
						interfasGrafica.llegoInformacion(line.substring(5));						
					}
					else if(line.startsWith(Protocolo.TK_MANDA_CLIENTES)){
						interfasGrafica.llegoListaClientes(line.substring(5));
					}
					else if(line.startsWith(Protocolo.TK_MANDA_LISTA_ARCH)){
						interfasGrafica.llegoListaArchivos(line.substring(5));
					}
					else if(line.startsWith(Protocolo.TK_RECIBE_ARCH)){
						interfasGrafica.llegoArchivo(line.substring(5));						
					}					
					else if(line.startsWith(Protocolo.TK_SERVIDOR_ABAJO)){
						interfasGrafica.servidorAbajo();						
					}
					else if(line.startsWith(Protocolo.TK_MENSAJE_A_TODOS)){
						interfasGrafica.mensajeATodos(line.substring(5));
					}
				}
			} catch (IOException e) {
			} finally { 
			}
		}
		try {
			if (s!=null) {
				s.close(); 
			}
		} catch (IOException e2) {
		}
	}
}

