package ClienteServidor;

import java.net.*;
import java.io.*;
import java.util.*;

public class ConectorServidor extends Thread { 

	public static final int default_port=6789;
	/** puerto usado en la conexin al definir el socket de servidor */
	protected int port;
	/** socket de servidor usado en las comunicaciones */
	protected ServerSocket listen_socket;
	/** vector de los clientes conectados al servidor */
	Vector clients;

	public boolean pleaseStop = false;
	
	public boolean conectado = false;
	RecibidorMensajesServidor interfasGrafica;

	public static void fail(Exception e,String msg) { 
		System.err.println(msg+":"+e);
		System.exit(1);
	}
	
	public void desconectar(){
		//barrer todo el vector y mandar un mensaje de desconexion
		broadcast(Protocolo.TK_SERVIDOR_ABAJO+Protocolo.chk("")+":",null);
		pleaseStop = true;
		stop();
		try{
			listen_socket.close();
		}
		catch(IOException ioe){
			
		}
		clients.removeAllElements(); 

	
	}	
	/** construye un servidor que escucha en el puerto port 
	@port nmero del puerto
	*/
	public ConectorServidor(int port,RecibidorMensajesServidor pInterGraf) {
		
		if (port==0) {
			port=default_port;
		}
		interfasGrafica= pInterGraf;
		
		this.port=port;
		try { 
			listen_socket=new ServerSocket(port); 
		} catch (IOException e) {
			interfasGrafica.noPudeConectar("Exception Creating Server Socket");
			fail(e,"Exception Creating Server Socket");
			return;
		}
		System.out.println("Server: listening on port "+port);
		interfasGrafica.conectado("Servidor escuchando en puerto "+ port);
		conectado = true;
		clients=new Vector();
		new quiter(this);
		this.start();
	}
	
	
	public void run() {
		try {
			while (!pleaseStop) {
				Socket client_socket=listen_socket.accept();
				myConnectionServer c=new myConnectionServer(this,client_socket);
				clients.addElement(c);
				System.out.println("un cliente nuevo "+clients.size());
				interfasGrafica.llegoClienteNuevo("Llego un cliente nuevo");
			}
		}
		catch (IOException e) {
			fail(e,"Exception while listening for connections");
		}
	}
	
	/** dar de baja la conexin mc (a un cliente) */
	void remove(myConnectionServer mc) {
		clients.removeElement(mc);
	}
	
	/** enviar a todos los clientes el mensaje msg que viene de la conexin mc0 */
	void broadcast(String msg,myConnectionServer mc0) {
		for (int i=0; i<clients.size();i++) {
			myConnectionServer mc=(myConnectionServer) clients.elementAt(i);
			mc.println(msg);
			System.out.println("mande "+msg+","+mc.id);
		}
	}
	String listaClientes(){
		String regreso = new String("");
		for (int i=0; i<clients.size();i++) {
			myConnectionServer mc=(myConnectionServer) clients.elementAt(i);
			regreso = regreso.concat(mc.id+",");
		}
		return regreso;
		
	}
	public void mandaMensajeATodos(String mensaje){
		broadcast(Protocolo.TK_MENSAJE_A_TODOS+Protocolo.chk("")+":"+mensaje,null);
	}
	
		
}
		
class myConnectionServer extends Thread {
	
	protected Socket client;
	protected BufferedReader in;
	protected PrintStream out;
	private ConectorServidor ms;
	protected boolean validada=false;
	protected boolean archivoAbierto=false;
	protected String id;
	
	
	public myConnectionServer(ConectorServidor ms,Socket client_socket) {
		this.ms=ms;
		client= client_socket;
		try {
			in=new BufferedReader(new InputStreamReader(client.getInputStream()));
			out=new PrintStream(client.getOutputStream());
		} catch (IOException e) {
			try {
				client.close(); 
			} catch (IOException e2) {
			}
			System.err.println("Exception while getting socket streams: "+e);
			return;
		}
		this.start();
	}
	
	void println(String msg) {
		out.println(msg);
	}
		
	public void run() {
		String line="";
		StringBuffer revline;
		int len;
		
		try {
			for (;;) { 
				line = in.readLine();
				System.out.println("Antes "+line);
				if (line==null||line.length()==0 || line.startsWith(Protocolo.TK_LOGOUT)) {
					System.out.println("por 0");
					break;
				}
				else if(!validada){
					if(!line.startsWith(Protocolo.TK_LOGIN)){
						ms.interfasGrafica.noSeIdentificoClienteNuevo("anonimo");
						break; // no es el protocolo cacelar
					}
					//buscarlo en la base de datos
					int r = estaEnBaseDeDatos(line);
					if(r ==0){
						System.out.println("por 1");
						validada=true; // ya esta validadada
						out.println(Protocolo.TK_LOGIN_OK+Protocolo.chk("")+":");
						ms.interfasGrafica.seDioDeAltaunClienteNuevo(id);
					}
					else if (r ==-1 || r == -2){
						System.out.println("por 2");
						out.println(Protocolo.TK_LOGIN_MAL+Protocolo.chk("")+":");
						ms.interfasGrafica.noSeIdentificoClienteNuevo(line+" (login incorrecto)");
						id=line;
						break; //cancelar conexion
					}
					else if (r ==-3){
						System.out.println("por 3");
						out.println(Protocolo.TK_PASSWORD_MAL+Protocolo.chk("")+":");
						ms.interfasGrafica.noSeIdentificoClienteNuevo(line+" (password incorrecto)");
						id=line;
						break; //cancelar conexion
					}
				}
				else{ // todos los demas mensajes
				
					if(line.startsWith(Protocolo.TK_MANDA_HORA)){
						//el cliente quiere saber la hora
						Date d = new Date();
						out.println(Protocolo.TK_MANDA_HORA+Protocolo.chk("")+":En el servidor son las "+d.getHours()+" hrs. con "+d.getMinutes()+" mins. y "+d.getSeconds()+" segs.");
						ms.interfasGrafica.accionCliente(id,"Pidio la hora");

					}
					else if(line.startsWith(Protocolo.TK_MANDA_CLIMA)){
						out.println(Protocolo.TK_MANDA_CLIMA+Protocolo.chk("")+":En el lugar donde esta el servidor el clima es: "+clima());							
						ms.interfasGrafica.accionCliente(id,"Pidio el clima");
					}
					else if(line.startsWith(Protocolo.TK_MANDA_CLIENTES)){
						String lista = ms.listaClientes();
						out.println(Protocolo.TK_MANDA_CLIENTES+Protocolo.chk("")+":"+lista);							
						ms.interfasGrafica.accionCliente(id,"Pidio Lista de Clientes");

					}
					else if(line.startsWith(Protocolo.TK_MANDA_LISTA_ARCH)){
						ListaDeArchivos lArch=new ListaDeArchivos();
						lArch.ext=".trf"; // los archivos trasfer file
						lArch.obtiene();
						String lista="";
						
						if(lArch.files == null || lArch.files.length == 0)
							System.out.println("No hay archivos");
						else{
							for (int i=0;i<lArch.files.length;i++) {
								lista = lista.concat(lArch.files[i]+",");
								System.out.println(lArch.files[i]);
							}
						}
						out.println(Protocolo.TK_MANDA_LISTA_ARCH+Protocolo.chk("")+":"+lista);	
						ms.interfasGrafica.accionCliente(id,"Pidio lista de Archivos");
												
					}
					else if(line.startsWith(Protocolo.TK_RECIBE_ARCH)){
						out.println(Protocolo.TK_RECIBE_ARCH+Protocolo.chk("")+":"+regresaArchivo(line.substring(5)));
						ms.interfasGrafica.accionCliente(id,"Pidio el archivo "+ line.substring(5) );
						
					}
				}
				
				//System.out.println("Dice:"+line);
				//ms.broadcast(line,this);
			}
		} catch (IOException e) {
			System.out.println("exeption");
			
		} finally {
			try { 
				client.close(); 
				ms.remove(this);
				System.out.println("Se da de Baja:"+line);
				ms.interfasGrafica.seDioDeBajaCliente(id);
			} catch(IOException e2) {
			}
		}
	}
	
	private String clima(){
		//genrar un clima a leatorio
		Random a = new Random();
		if(a.nextDouble()<0.25)
			return "Soleado";
		if(a.nextDouble()<0.5)
			return "Nublado";
		if(a.nextDouble()<0.75)
			return "Lluvioso";
		return "Templado";
		
	}

	private String regresaArchivo(String Archivo){

		try{
			RandomAccessFile raf=new RandomAccessFile(Archivo,"r");
			byte[] b=new byte[(int)raf.length()];
			raf.readFully(b);
			for(int i=0;i<raf.length();i++){
				System.out.println(">"+(int)b[i]+"<\n");
				if((int)b[i] == 13)
					b[i]=(byte)'~';
				else if((int)b[i] == 10)
					b[i]=(byte)'$';

			}
			raf.close();
			return new String(b);
		}
		catch (IOException e){
			System.out.println(e+"->" +e.getMessage());
			return "";
		}
	}
	private int estaEnBaseDeDatos(String sLogin){
		int separador=sLogin.indexOf(",");
		int inicio =sLogin.indexOf(":");
		long totRegs=0;
		String nomArch = "Base.dat";
		int lenReg=16;
		
		
		if(separador == -1 || inicio ==-1 )
			return -1;
			
		//Sacar Login
		String id = sLogin.substring(inicio+1   ,separador);
		while(id.length()<8)
			id = id.concat(" ");
			
		System.out.println("El id2 "+id+"<");
		//Sacar passw
		String pw = sLogin.substring(separador+1,sLogin.length());
		while(pw.length()<8)
			pw = pw.concat(" ");
		System.out.println("El pw2 "+pw+"<");


		
		try{
			RandomAccessFile raf=new RandomAccessFile(nomArch,"r");
			totRegs=raf.length()/lenReg;
			
			System.out.println(totRegs);
			if(totRegs==0)
				return -2;
				
			byte lectura[]=new byte[8];
			String unID,unPW;
			for(int i =0 ; i < totRegs; i++){
				raf.read(lectura,0,8);
				unID = new String(lectura);
				
				raf.read(lectura,0,8);
				unPW = new String(lectura);

				raf.read(lectura,0,2);// quitar CR LF
	
				if(unID.equals(id))
					if(unPW.equals(pw)){
						raf.close();
						//guardar el id
						this.id = id;
						return 0; //todo ok;
					}
					else{
						raf.close();
						return -3;
					}
					
				System.out.println(">"+unID+"<");
				System.out.println(">"+unPW+"<");
			}
			raf.close();

		}
		catch (IOException e){
			System.out.println(e+"->" +e.getMessage());
			return -2;
		}

		return -2; //todo ok
		//return -2 // no existe ID
		//return -3 // pasword incorrecto
		
	}
		
}

class quiter extends Thread {

	BufferedReader br;
	Thread th;
	
	quiter(Thread th) {
		this.th=th;
		br=new BufferedReader(new InputStreamReader(System.in));
		this.start();
	}
	
	public void run() {
		try {
			String str=br.readLine();
		} catch (IOException ioe) {
		} finally {
			System.exit(0);
		}
	}

}
