package ClienteServidor;

import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.util.Date;

class InterfasGraficaServidor extends Frame implements RecibidorMensajesServidor,WindowListener,ActionListener{
	MenuBar mB=new MenuBar();
	Menu mConfiguracion=new Menu("Configuracion");
	MenuItem mIServidor = new MenuItem("Datos de Servidor");
	
	Label lbMensajes = new Label("Desconectado.");

	TextField TFMensajeATodos = new TextField();
	Button bMandaATodos = new Button("Manda un Mensaje a Todos");	

	TextField TFInformacion = new TextField("No ha llegado informacion...");


	TextArea TABitacora = new TextArea("");	
	
	Choice chClientes = new Choice();
	
	int port = ConectorCliente.default_port;
	
	ConectorServidor conecServer;
	
	InterfasGraficaServidor(){
		
		Label lbTitulo = new Label("Bitacora de servidor");
		Label lbClientes = new Label("Clientes:");
		lbClientes.setAlignment(Label.CENTER); 
		lbClientes.setBackground(Color.red);
		lbClientes.setForeground(Color.white);
		lbClientes.setFont(new Font("",Font.BOLD,13));

		lbTitulo.setForeground(Color.red);
		lbTitulo.setFont(new Font("",Font.BOLD,13));

		setMenuBar(mB);
		
		mB.add(mConfiguracion);
		
		mConfiguracion.add(mIServidor);


		setLayout(new BorderLayout());
		Panel pN  = new Panel();
		Panel pS = new Panel();
		Panel pSW = new Panel();
		Panel pNS  = new Panel();
		pNS.setLayout(new GridLayout(1,3));
		
		pNS.add(lbTitulo);
		pNS.add(lbClientes);
		pNS.add(chClientes);
		
		pN.setLayout(new BorderLayout());
		
		pN.add("Center",TFMensajeATodos);
		pN.add("East",bMandaATodos);
		pN.add("South",pNS);
		
		add("Center",TABitacora);
		
		pS.setLayout(new BorderLayout());
		
		pS.add("West",pSW);
		pS.add("Center",lbMensajes);
		
		pSW.setSize(new Dimension(400,400));

		
		add("North",pN);
		add("South",pS);
		
		lbMensajes.setBackground(Color.red);
		lbMensajes.setForeground(Color.white);
		lbMensajes.setFont(new Font("",Font.BOLD,13));

		
		addWindowListener(this);
		
	
		bMandaATodos.addActionListener(this);
		mIServidor.addActionListener(this);
		
		ConfiguraPuerto cP = new ConfiguraPuerto(this,"Configura el puerto del socket servidor :-) ",true,10,10,350,150,port );
		port = cP.puerto;
		cP.dispose();
		
		conecServer = new ConectorServidor(port,this);
	}
	
	public static void main(String args[]){
		InterfasGraficaServidor mainFrame = new InterfasGraficaServidor();
		
		mainFrame.setSize(500, 400);
		mainFrame.setTitle("EL Servidor:");
		mainFrame.setVisible(true);
	}
	
	public String hora(){
		Date d = new Date();
		return "\n"+d.getHours()+":"+d.getMinutes()+":"+d.getSeconds()+": ";
	}
	/*Funciones de Recibidor de Mensajes**********************/
	public void conectado(String informacion){
		lbMensajes.setText(informacion);
	}
	public void noPudeConectar(String informacion){
		lbMensajes.setText(informacion);
	}

	public void llegoClienteNuevo(String idCliente){
		TABitacora.append(hora()+idCliente);
	}

	public void seDioDeBajaCliente(String idCliente){
		TABitacora.append(hora()+"Se dio de Baja :"+idCliente);
		chClientes.remove(idCliente);
	}
	
	public void accionCliente(String idCliente,String accion){
		TABitacora.append(hora()+"El cliente "+idCliente+" "+accion);

	}

	public void seDioDeAltaunClienteNuevo(String idCliente){
		TABitacora.append(hora()+"Se ha dado de alta: "+idCliente);
		chClientes.add(idCliente);
	}

	public void noSeIdentificoClienteNuevo(String idCliente){
		TABitacora.append(hora()+"Fracaso el dado de alta de: "+idCliente);
	}


	/*Funciones de Window ****************************************/
    public void windowOpened(WindowEvent e){}
    public void windowActivated(WindowEvent e){}
    public void windowDeactivated(WindowEvent e){}
    public void windowIconified(WindowEvent e){}
    public void windowDeiconified(WindowEvent e){}
    public void windowClosed(WindowEvent e){}
	public void windowClosing(WindowEvent e){
		
		System.out.println("aqui");
		if(conecServer != null && conecServer.conectado == true){
			System.out.println("va a desconectar");
			conecServer.desconectar();
		}
		setVisible(false);
		dispose();
		System.exit(0);
	}
	
	/*Funciones de Action Event*******************************************************/
	public void actionPerformed(ActionEvent e){
		if(e.getSource()==bMandaATodos){
			conecServer.mandaMensajeATodos(TFMensajeATodos.getText());
		}
		else if(e.getSource() == mIServidor){

			ConfiguraPuerto cP = new ConfiguraPuerto(this,"Configura el puerto del socket servidor :-) ",true,10,10,350,150,port );
			if(cP.acepto){
				if(port != cP.puerto){
					conecServer.desconectar();
					conecServer=null;
					System.gc();
					conecServer = new ConectorServidor(cP.puerto,this);		
				}
				port = cP.puerto;
			}
			cP.dispose();
			
			
		}


	}


}

